Loading...
Searching...
No Matches
hueplusplus::SimpleColorHueStrategy Class Reference

`#include <hueplusplus/SimpleColorHueStrategy.h>`

Inheritance diagram for hueplusplus::SimpleColorHueStrategy:
[legend]
Collaboration diagram for hueplusplus::SimpleColorHueStrategy:
[legend]

## Public Member Functions

bool | setColorHue (uint16_t hue, uint8_t transition, Light &light) const override
| Function for changing a lights color in hue with a specified transition.
bool | setColorSaturation (uint8_t sat, uint8_t transition, Light &light) const override
| Function for changing a lights color in saturation with a specified transition.
bool | setColorHueSaturation (const HueSaturation &hueSat, uint8_t transition, Light &light) const override
| Function for changing a lights color in hue and saturation format with a specified transition.
bool | setColorXY (const XYBrightness &xy, uint8_t transition, Light &light) const override
| Function for changing a lights color in CIE format with a specified transition.
bool | setColorLoop (bool on, Light &light) const override
| Function for turning on/off the color loop feature of a light.
bool | alertHueSaturation (const HueSaturation &hueSat, Light &light) const override
| Function that lets the light perform one breath cycle in the specified color.
bool | alertXY (const XYBrightness &xy, Light &light) const override
| Function that lets the light perform one breath cycle in the specified color.
HueSaturation | getColorHueSaturation (Light &light) const override
| Function that returns the current color of the light as hue and saturation.
HueSaturation | getColorHueSaturation (const Light &light) const override
| Function that returns the current color of the light as hue and saturation.
XYBrightness | getColorXY (Light &light) const override
| Function that returns the current color of the light as xy.
XYBrightness | getColorXY (const Light &light) const override
| Function that returns the current color of the light as xy.
Public Member Functions inherited from hueplusplus::ColorHueStrategy
virtual | ~ColorHueStrategy ()=default
| Virtual dtor.

## Detailed Description

Class implementing the functions of ColorHueStrategy

To be used for lights that have only color and no color temperature.

## Member Function Documentation

## alertHueSaturation()

bool hueplusplus::SimpleColorHueStrategy::alertHueSaturation | ( | const HueSaturation & | hueSat,
|  | Light & | light ) const

override virtual

Function that lets the light perform one breath cycle in the specified color.

Parameters

  hueSat | The color in hue and saturation
  light | A reference of the light

Blocks for the time a Light::alert() needs

Implements hueplusplus::ColorHueStrategy.

## alertXY()

bool hueplusplus::SimpleColorHueStrategy::alertXY | ( | const XYBrightness & | xy,
|  | Light & | light ) const

override virtual

Function that lets the light perform one breath cycle in the specified color.

Parameters

  xy | The color in XY and brightness
  light | A reference of the light

Implements hueplusplus::ColorHueStrategy.

## getColorHueSaturation() [1/2]

HueSaturation hueplusplus::SimpleColorHueStrategy::getColorHueSaturation | ( | const Light & | light | ) | const

override virtual

Function that returns the current color of the light as hue and saturation.

Note
  This does not update the lights state

Parameters

  light | A const reference of the light

Returns
  Pair containing the hue as first value and saturation as second value

Implements hueplusplus::ColorHueStrategy.

## getColorHueSaturation() [2/2]

HueSaturation hueplusplus::SimpleColorHueStrategy::getColorHueSaturation | ( | Light & | light | ) | const

override virtual

Function that returns the current color of the light as hue and saturation.

Updates the lights state by calling refreshState()

Parameters

  light | A reference of the light

Returns
  Pair containing the hue as first value and saturation as second value

Implements hueplusplus::ColorHueStrategy.

## getColorXY() [1/2]

XYBrightness hueplusplus::SimpleColorHueStrategy::getColorXY | ( | const Light & | light | ) | const

override virtual

Function that returns the current color of the light as xy.

Note
  This does not update the lights state

Parameters

  light | A const reference of the light

Returns
  XY and brightness of current color

Implements hueplusplus::ColorHueStrategy.

## getColorXY() [2/2]

XYBrightness hueplusplus::SimpleColorHueStrategy::getColorXY | ( | Light & | light | ) | const

override virtual

Function that returns the current color of the light as xy.

Updates the lights state by calling refreshState()

Parameters

  light | A reference of the light

Returns
  XY and brightness of current color

Implements hueplusplus::ColorHueStrategy.

## setColorHue()

bool hueplusplus::SimpleColorHueStrategy::setColorHue | ( | uint16_t | hue,
|  | uint8_t | transition,
|  | Light & | light ) const

override virtual

Function for changing a lights color in hue with a specified transition.

The hue ranges from 0 to 65535, whereas 65535 and 0 are red, 25500 is green and 46920 is blue.

Parameters

  hue | The hue of the color
  transition | The time it takes to fade to the new color in multiples of 100ms, 4 = 400ms and should be seen as the default
  light | A reference of the light

Implements hueplusplus::ColorHueStrategy.

## setColorHueSaturation()

bool hueplusplus::SimpleColorHueStrategy::setColorHueSaturation | ( | const HueSaturation & | hueSat,
|  | uint8_t | transition,
|  | Light & | light ) const

override virtual

Function for changing a lights color in hue and saturation format with a specified transition.

Parameters

  hueSat | Color in hue and satuation.
  transition | The time it takes to fade to the new color in multiples of 100ms, 4 = 400ms and should be seen as the default
  light | A reference of the light

Implements hueplusplus::ColorHueStrategy.

## setColorLoop()

bool hueplusplus::SimpleColorHueStrategy::setColorLoop | ( | bool | on,
|  | Light & | light ) const

override virtual

Function for turning on/off the color loop feature of a light.

Can be theoretically set for any light, but it only works for lights that support this feature. When this feature is activated the light will fade through every color on the current hue and saturation settings. Notice that none of the setter functions check whether this feature is enabled and the colorloop can only be disabled with this function or by simply calling off() and then on(), so you could alternatively call off() and then use any of the setter functions.

Parameters

  on | Boolean to turn this feature on or off, true/1 for on and false/0 for off
  light | A reference of the light

Implements hueplusplus::ColorHueStrategy.

## setColorSaturation()

bool hueplusplus::SimpleColorHueStrategy::setColorSaturation | ( | uint8_t | sat,
|  | uint8_t | transition,
|  | Light & | light ) const

override virtual

Function for changing a lights color in saturation with a specified transition.

The saturation ranges from 0 to 254, whereas 0 is least saturated (white) and 254 is most saturated (vibrant).

Parameters

  sat | The saturation of the color
  transition | The time it takes to fade to the new color in multiples of 100ms, 4 = 400ms and should be seen as the default
  light | A reference of the light

Implements hueplusplus::ColorHueStrategy.

## setColorXY()

bool hueplusplus::SimpleColorHueStrategy::setColorXY | ( | const XYBrightness & | xy,
|  | uint8_t | transition,
|  | Light & | light ) const

override virtual

Function for changing a lights color in CIE format with a specified transition.

Parameters

  xy | The color in XY and brightness
  transition | The time it takes to fade to the new color in multiples of 100ms, 4 = 400ms and should be seen as the default
  light | A reference of the light

Implements hueplusplus::ColorHueStrategy.

The documentation for this class was generated from the following files:

- include/hueplusplus/SimpleColorHueStrategy.h
- src/SimpleColorHueStrategy.cpp